; property lists

(define (put var property value)
   (if (null? var) (set! var 'nil))
   (if (not (symbol? var))
       (error "Non-symbol argument to put" var))
   (if (eq? property 'pname)
       (error "The pname property is inviolate" var))
   (let ((entry (assq property (cdr (->pair var)))))
      (if entry
          (set-cdr! entry value)
          (set-cdr! (->pair var)
                    (cons (cons property value)
                          (cdr (->pair var)))))
      value))

(define (putprop var value property)
  (put var property value))

(define (get var property)
   (if (null? var) (set! var 'nil))
   (if (not (symbol? var))
       (error "Non-symbol argument to get" var))
   (let ((entry (assq property (cdr (->pair var)))))
      (if entry (cdr entry) #!false)))
